/*
 *  data_streamer.cpp -- Metadata handler thread
 *
 *  Copyright (C) 2004 Tony Sin(x) '76 <administrator@tortugalabs.it>
 *  All rights reserved.
 *
 */

/*
 *			 GNU GENERAL PUBLIC LICENSE
 *			    Version 2, June 1991
 *
 *  Copyright (C) 1989, 1991 Free Software Foundation, Inc.
 *                           675 Mass Ave, Cambridge, MA 02139, USA
 *  Everyone is permitted to copy and distribute verbatim copies
 *  of this license document, but changing it is not allowed.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifdef HAVE_CONFIG_H
  #ifndef __main_config_h__
    #define __main_config_h__
    #include "../config.h"
  #endif

  #ifdef HAVE_STRING_H
    #include <string.h>
  #endif

  #ifdef HAVE_UNISTD_H
    #include <unistd.h>
  #endif
#endif

#include "globals.h"
#include "data_streamer.h"

void *data_streamer(void *arg)
{
  char *meta_data_array[4];
  int rotate = 0, idx, key;

  sig_obj->Block();

  if ((conf_obj->GetValue(_metaupdate) == NULL) || (atoi(conf_obj->GetValue(_metaupdate)) > 0))
  {
    for (idx = 0, key = ((int) _genre); key < ((int) _bitrate); key++)
      if (conf_obj->GetValue((key_type) key) != NULL)
      {
        meta_data_array[idx] = new char[strlen(conf_obj->GetValue((key_type) key))+1];
        strcpy(meta_data_array[idx++],conf_obj->GetValue((key_type) key));
      }

    meta_data_array[idx] = new char[255];
    strcpy(meta_data_array[idx],"No song");

    while (!ok_to_end)
    {
      sem_obj->Wait(data_mutex);

      if (changed)
      {
        ready_obj->GetFile(meta_data_array[idx]);
        *(meta_data_array[idx]+(strlen(meta_data_array[idx])-4)) = '\0';
        changed = false;
      }

      stream_obj->UpdateMetaData(meta_data_array[rotate++ % (idx+1)]);

      sem_obj->Signal(data_mutex);

      sleep(((conf_obj->GetValue(_metaupdate) != NULL)? atoi(conf_obj->GetValue(_metaupdate)) : 5));
    }

    for (rotate = 0; rotate <= idx; rotate++)
      delete [] meta_data_array[rotate];
  }

  return NULL;
}
